public class EsempioParametri
{
	private int volte;

	public EsempioParametri(int v)
	{
		volte = v;
	}

	public EsempioParametri()
	{
		this(3);
	}

	public int stampa(String s)
	{
		int i = 0;
		for(i=0;i<volte-1;i++)
		{
			System.out.print(s);
		}
		System.out.println(s);
		return volte;
	}

	public int getVolte()
	{
		return volte;
	}

	public String toString()
	{
		return "io stampo " + volte + " volte";
	}

	public EsempioParametri incrementaVolte(int i)
	{
		/* questa agisce sull'oggetto stesso
		volte = volte + i;
		return this;
		*/
		//questa crea un nuovo oggetto con il nuovo valore
		return new EsempioParametri(volte + i);
	}

	public static void main(String[] argv)
	{
		EsempioParametri ep1, ep2;
		ep1 = new EsempioParametri(Integer.parseInt(argv[0]));
		ep2 = new EsempioParametri(Integer.parseInt(argv[1]));

		// la chiamata a toString non valuta al tipo corretto
		//EsempioParametri ep3 = new EsempioParametri(ep1.toString());
		ep1.stampa(argv[2]);
		ep2.stampa(argv[3]);

		String s = "paperino";
		System.out.println(s.toUpperCase());
		System.out.println(s);

		ep1 = ep1.incrementaVolte(2);

		EsempioParametri ep3 = ep1.incrementaVolte(2);
		ep1.stampa(argv[2]);
		ep3.stampa(argv[2]);

	}
}
