package mediateca;

public class Mediateca
{
	Map<String, List<Media>> perTipo, perTitolo, perCategoria;

	public Mediateca()
	{
		perTipo = new HashMap<String, List<Media>>();
		perTitolo = new TreeMap<String, List<Media>>();
		perCategoria = new TreeMap<String, List<Media>>();
	}

	public static void main(String[] argv)
	{
		(new Mediateca()).exec(argv);
	}

	void exec(String[] argv)
	{
		for(int i = 0;i<argv.length;i++)
		{
			leggiDati(argv[i]);
		}

		System.out.println(perTipo);
		System.out.println(perTitolo);
		System.out.println(perCategoria);
	}

	void leggiDati(String nomeFile)
	{
		Scanner sc = null;
		try
		{
			sc = new Scanner(new FileInputStream(nomeFile));
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
			return;
		}

		while(sc.hasNextLine())
		{
			String tipo = sc.nextLine();
			Media m = null;
			if(tipo.equalsIgnoreCase("dvd"))
			{
				m = new Dvd();
			}
			else if(tipo.equalsIgnoreCase("audiocd"))
			{
				m = new AudioCd();
			}
			else
			{
				System.out.println("Non conosco il tipo media <" + tipo + ">");
				continue;
			}
			m.popolaCampi(sc);

			List<Media> l = perTipo.get(tipo);
			if(l == null)
			{
				l = new LinkedList<Media>();
				perTipo.put(tipo, l);
			}
			l.add(m);

			l = perTitolo.get(m.titolo);
			if(l == null)
			{
				l = new LinkedList<Media>();
				perTitolo.put(titolo, l);
			}
			l.add(m);

			l = perCategoria.get(m.categoria);
			if(l == null)
			{
				l = new LinkedList<Media>();
				perCategoria.put(categoria, l);
			}
			l.add(m);
		}
	}
}
